object OfficerTypes;

//=======================| OFFICERS |=======================//
#define OFFIC_TYPE_REGCAP 		"captain"// NK -->
#define OFFIC_TYPE_CAPMERCHANT	"merchant captain"
#define OFFIC_TYPE_CAPPRIVATEER	"privateer captain" // PB
#define OFFIC_TYPE_CAPNAVY 		"navy captain"
#define OFFIC_TYPE_CAPPIRATE	"pirate captain"
#define OFFIC_TYPE_RANDCHAR 	"fighter"
#define OFFIC_TYPE_CIVILIAN 	"civilian"// NK <--
#define OFFIC_TYPE_BOATSWAIN 	"boatswain"
#define OFFIC_TYPE_CANNONEER 	"cannoneer"
#define OFFIC_TYPE_QMASTER 		"quartermaster"
#define OFFIC_TYPE_NAVIGATOR 	"navigator"
#define OFFIC_TYPE_FIRSTMATE 	"first mate"
#define OFFIC_TYPE_CARPENTER 	"carpenter"// MAXIMUS -->
#define OFFIC_TYPE_DOCTOR 		"doctor"
#define OFFIC_TYPE_ABORDAGE 	"deck fighter"// MAXIMUS <--
#define OFFIC_TYPE_TRADER		"trader" // KK
#define OFFIC_TYPE_GUARD		"guard" // Levis
#define OFFIC_TYPE_SHOPKEEPER	"shop merchant" // Levis

void InitOfficerTypes()
{
	//Set Personal Perk
	OfficerTypes.Combat.perks.BasicDefence = 1;
	OfficerTypes.Combat.perks.AdvancedDefence = 1;
	OfficerTypes.Combat.perks.Toughness = 1;
	OfficerTypes.Combat.perks.CriticalHit = 1;
	OfficerTypes.Combat.perks.SwordplayProfessional = 1;
	OfficerTypes.Combat.perks.Gunman = 1;
	OfficerTypes.Combat.perks.GunProfessional = 1;
	OfficerTypes.Combat.perks.ImproveAiming = 1;
	OfficerTypes.Combat.perks.GunFighter = 1;
	OfficerTypes.Combat.perks.Rush = 1;

	string type = OFFIC_TYPE_RANDCHAR;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 2;
	OfficerTypes.(type).skills.Fencing.importance = 8;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 1;
	OfficerTypes.(type).skills.Accuracy.importance = 4;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).CanRand = 1;
	OfficerTypes.(type).EnemyType = 1;
	OfficerTypes.(type).rankbonus = -5;
	if(isPerkExisting("ImprovePotions")) {OfficerTypes.(type).perks.ImprovePotions = 1};
	if(isPerkExisting("DefendPoison")) {OfficerTypes.(type).perks.DefendPoison = 1};
	if(isPerkExisting("HighStakes")) {OfficerTypes.(type).perks.HighStakes = 1};
	
	type = OFFIC_TYPE_CIVILIAN;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).CanRand = 1;
	OfficerTypes.(type).rankbonus = -10;
	//Just some perks for him so he looks less pathetic
	if(isPerkExisting("BasicCommerce")) {OfficerTypes.(type).perks.BasicCommerce = 1};
	if(isPerkExisting("LightRepair")) {OfficerTypes.(type).perks.LightRepair = 1};
	if(isPerkExisting("HighStakes")) {OfficerTypes.(type).perks.HighStakes = 1};
	if(isPerkExisting("ShipSpeedUp")) {OfficerTypes.(type).perks.ShipSpeedUp = 1};
	if(isPerkExisting("SailsDamageUp")) {OfficerTypes.(type).perks.SailsDamageUp = 1};
	
	//This one is used for shopkeepers
	type = OFFIC_TYPE_SHOPKEEPER;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 2;
	OfficerTypes.(type).skills.Commerce.importance = 10;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).skills.Sneak.importance = 4;
//	OfficerTypes.(type).CanRand = 1;
	OfficerTypes.(type).rankbonus = -15;
	OfficerTypes.(type).hpbasebonus = 20;
	OfficerTypes.(type).hplevelbonus = 2;
	if(isPerkExisting("BasicCommerce")) {OfficerTypes.(type).perks.BasicCommerce = 1};
	if(isPerkExisting("AdvancedCommerce")) {OfficerTypes.(type).perks.AdvancedCommerce = 1};
	if(isPerkExisting("Trustworthy")) {OfficerTypes.(type).perks.Trustworthy = 1};
	if(isPerkExisting("BasicLandOwner")) {OfficerTypes.(type).perks.BasicLandOwner = 1};
	
	//This one is used for townguards
	type = OFFIC_TYPE_GUARD;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 10;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Accuracy.importance = 4;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Defence.importance = 4;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).rankbonus = 10;
	OfficerTypes.(type).hpbasebonus = 30;
	OfficerTypes.(type).hplevelbonus = 5;
	if(isPerkExisting("ImprovePotions")) {OfficerTypes.(type).perks.ImprovePotions = 1};
	if(isPerkExisting("DefendPoison")) {OfficerTypes.(type).perks.DefendPoison = 1};
	
	type = OFFIC_TYPE_CAPMERCHANT;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Sailing.importance = 8;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Repair.importance = 3;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Defence.importance = 2;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Commerce.importance = 6;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).skills.Sneak.importance = 3;
	OfficerTypes.(type).notcontribute = 1;
	OfficerTypes.(type).rankbonus = 3;
	OfficerTypes.(type).hpbasebonus = 25;
	OfficerTypes.(type).crewtype = OFFIC_TYPE_GUARD;
	if(isPerkExisting("ShipTurnRateUp")) {OfficerTypes.(type).perks.ShipTurnRateUp = 1};
	if(isPerkExisting("ShipSpeedUp")) {OfficerTypes.(type).perks.ShipSpeedUp = 1};
	if(isPerkExisting("SandbankManeuver")) {OfficerTypes.(type).perks.SandbankManeuver = 1};
	if(isPerkExisting("StormProfessional")) {OfficerTypes.(type).perks.StormProfessional = 1};
	if(isPerkExisting("SailingProfessional")) {OfficerTypes.(type).perks.SailingProfessional = 1};
	if(isPerkExisting("BasicBattleState")) {OfficerTypes.(type).perks.BasicBattleState = 1};
	if(isPerkExisting("SailsDamageUp")) {OfficerTypes.(type).perks.SailsDamageUp = 1};
	if(isPerkExisting("LightRepair")) {OfficerTypes.(type).perks.LightRepair = 1};
	if(isPerkExisting("InstantRepair")) {OfficerTypes.(type).perks.InstantRepair = 1};
	if(isPerkExisting("Cooking")) {OfficerTypes.(type).perks.Cooking = 1};
	if(isPerkExisting("BasicCommerce")) {OfficerTypes.(type).perks.BasicCommerce = 1};
	if(isPerkExisting("AdvancedCommerce")) {OfficerTypes.(type).perks.AdvancedCommerce = 1};
	if(isPerkExisting("Trustworthy")) {OfficerTypes.(type).perks.Trustworthy = 1};
	if(isPerkExisting("SharedExperience")) {OfficerTypes.(type).perks.SharedExperience = 1};
	
	type = OFFIC_TYPE_REGCAP;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Leadership.importance = 7;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 4;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Sailing.importance = 5;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Accuracy.importance = 3;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Cannons.importance = 3;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Grappling.importance = 4;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Repair.importance = 2;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Defence.importance = 6;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).notcontribute = 1;
	OfficerTypes.(type).rankbonus = 5;
	OfficerTypes.(type).hpbasebonus = 10;
	if(isPerkExisting("BasicBattleState")) {OfficerTypes.(type).perks.BasicBattleState = 1};
	if(isPerkExisting("AdvancedBattleState")) {OfficerTypes.(type).perks.AdvancedBattleState = 1};
	if(isPerkExisting("ShipSpeedUp")) {OfficerTypes.(type).perks.ShipSpeedUp = 1};
	if(isPerkExisting("FastReload")) {OfficerTypes.(type).perks.FastReload = 1};
	if(isPerkExisting("HullDamageUp")) {OfficerTypes.(type).perks.HullDamageUp = 1};
	if(isPerkExisting("SailsDamageUp")) {OfficerTypes.(type).perks.SailsDamageUp = 1};
	if(isPerkExisting("CrewDamageUp")) {OfficerTypes.(type).perks.CrewDamageUp = 1};
	if(isPerkExisting("CriticalShoot")) {OfficerTypes.(type).perks.CriticalShoot = 1};
	if(isPerkExisting("LongRangeShoot")) {OfficerTypes.(type).perks.LongRangeShoot = 1};
	if(isPerkExisting("LongRangeGrappling")) {OfficerTypes.(type).perks.LongRangeGrappling = 1};
	if(isPerkExisting("MusketsShoot")) {OfficerTypes.(type).perks.MusketsShoot = 1};
	if(isPerkExisting("LightRepair")) {OfficerTypes.(type).perks.LightRepair = 1};
	if(isPerkExisting("IronWill")) {OfficerTypes.(type).perks.IronWill = 1};

	type = OFFIC_TYPE_CAPNAVY;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Leadership.importance = 8;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 4;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Sailing.importance = 6;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Accuracy.importance = 2;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Cannons.importance = 3;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).notcontribute = 1;
	OfficerTypes.(type).rankbonus = 10;
	OfficerTypes.(type).hpbasebonus = 40;
	OfficerTypes.(type).hplevelbonus = 2;
	OfficerTypes.(type).crewtype = OFFIC_TYPE_GUARD;
	if(isPerkExisting("BasicBattleState")) {OfficerTypes.(type).perks.BasicBattleState = 1};
	if(isPerkExisting("AdvancedBattleState")) {OfficerTypes.(type).perks.AdvancedBattleState = 1};
	if(isPerkExisting("ShipDefenceProfessional")) {OfficerTypes.(type).perks.ShipDefenceProfessional = 1};
	if(isPerkExisting("FastReload")) {OfficerTypes.(type).perks.FastReload = 1};
	if(isPerkExisting("HullDamageUp")) {OfficerTypes.(type).perks.HullDamageUp = 1};
	if(isPerkExisting("SailsDamageUp")) {OfficerTypes.(type).perks.SailsDamageUp = 1};
	if(isPerkExisting("CrewDamageUp")) {OfficerTypes.(type).perks.CrewDamageUp = 1};
	if(isPerkExisting("CriticalShoot")) {OfficerTypes.(type).perks.CriticalShoot = 1};
	if(isPerkExisting("LongRangeShoot")) {OfficerTypes.(type).perks.LongRangeShoot = 1};
	if(isPerkExisting("CannonProfessional")) {OfficerTypes.(type).perks.CannonProfessional = 1};
	if(isPerkExisting("Troopers")) {OfficerTypes.(type).perks.Troopers = 1};
	if(isPerkExisting("LightRepair")) {OfficerTypes.(type).perks.LightRepair = 1};
	if(isPerkExisting("HighStakes")) {OfficerTypes.(type).perks.HighStakes = 1};
	if(isPerkExisting("IronWill")) {OfficerTypes.(type).perks.IronWill = 1};
	
	type = OFFIC_TYPE_CAPPIRATE;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 10;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Sailing.importance = 3;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Accuracy.importance = 3;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Cannons.importance = 5;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Grappling.importance = 8;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).notcontribute = 1;
//	OfficerTypes.(type).CanRand = 1;
	OfficerTypes.(type).rankbonus = 8;
	OfficerTypes.(type).hpbasebonus = 10;
	OfficerTypes.(type).hplevelbonus = 5;
	OfficerTypes.(type).crewtype = OFFIC_TYPE_ABORDAGE;
	if(isPerkExisting("DefendPoison")) {OfficerTypes.(type).perks.DefendPoison = 1};
	if(isPerkExisting("ShipTurnRateUp")) {OfficerTypes.(type).perks.ShipTurnRateUp = 1};
	if(isPerkExisting("ShipSpeedUp")) {OfficerTypes.(type).perks.ShipSpeedUp = 1};
	if(isPerkExisting("StormProfessional")) {OfficerTypes.(type).perks.StormProfessional = 1};
	if(isPerkExisting("SailsDamageUp")) {OfficerTypes.(type).perks.SailsDamageUp = 1};
	if(isPerkExisting("CrewDamageUp")) {OfficerTypes.(type).perks.CrewDamageUp = 1};
	if(isPerkExisting("LongRangeShoot")) {OfficerTypes.(type).perks.LongRangeShoot = 1};
	if(isPerkExisting("LongRangeGrappling")) {OfficerTypes.(type).perks.LongRangeGrappling = 1};
	if(isPerkExisting("MusketsShoot")) {OfficerTypes.(type).perks.MusketsShoot = 1};
	if(isPerkExisting("GrapplingProfessional")) {OfficerTypes.(type).perks.GrapplingProfessional = 1};
	if(isPerkExisting("LightRepair")) {OfficerTypes.(type).perks.LightRepair = 1};
	if(isPerkExisting("ImproveSmuggling")) {OfficerTypes.(type).perks.ImproveSmuggling = 1};
	if(isPerkExisting("SharedExperience")) {OfficerTypes.(type).perks.SharedExperience = 1};
	if(isPerkExisting("Brander")) {OfficerTypes.(type).perks.Brander = 1};

	type = OFFIC_TYPE_CAPPRIVATEER;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Leadership.importance = 8;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 8;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Sailing.importance = 6;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Repair.importance = 5;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).skills.Sneak.importance = 3;
	OfficerTypes.(type).notcontribute = 1;
//	OfficerTypes.(type).CanRand = 1;
	OfficerTypes.(type).rankbonus = 8;
	OfficerTypes.(type).hpbasebonus = 20;
	OfficerTypes.(type).hplevelbonus = 4;
	if(isPerkExisting("DefendPoison")) {OfficerTypes.(type).perks.DefendPoison = 1};
	if(isPerkExisting("BasicBattleState")) {OfficerTypes.(type).perks.BasicBattleState = 1};
	if(isPerkExisting("AdvancedBattleState")) {OfficerTypes.(type).perks.AdvancedBattleState = 1};
	if(isPerkExisting("FastReload")) {OfficerTypes.(type).perks.FastReload = 1};
	if(isPerkExisting("ShipTurnRateUp")) {OfficerTypes.(type).perks.ShipTurnRateUp = 1};
	if(isPerkExisting("ShipSpeedUp")) {OfficerTypes.(type).perks.ShipSpeedUp = 1};
	if(isPerkExisting("StormProfessional")) {OfficerTypes.(type).perks.StormProfessional = 1};
	if(isPerkExisting("SandbankManeuver")) {OfficerTypes.(type).perks.SandbankManeuver = 1};
	if(isPerkExisting("SailingProfessional")) {OfficerTypes.(type).perks.SailingProfessional = 1};
	if(isPerkExisting("Cooking")) {OfficerTypes.(type).perks.Cooking = 1};
	if(isPerkExisting("LightRepair")) {OfficerTypes.(type).perks.LightRepair = 1};
	if(isPerkExisting("IronWill")) {OfficerTypes.(type).perks.IronWill = 1};
	if(isPerkExisting("BasicCommerce")) {OfficerTypes.(type).perks.BasicCommerce = 1};
	if(isPerkExisting("SharedExperience")) {OfficerTypes.(type).perks.SharedExperience = 1};
	if(isPerkExisting("Brander")) {OfficerTypes.(type).perks.Brander = 1};

	//Boatswain
	type = OFFIC_TYPE_BOATSWAIN;
	OfficerTypes.(type).skills.Leadership = 1;
	OfficerTypes.(type).skills.Leadership.importance = 5;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 3;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 2;
	OfficerTypes.(type).skills.Grappling.importance = 10;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).usableoffictype = true;
//	OfficerTypes.(type).CanRand = 1;
	OfficerTypes.(type).hplevelbonus = 3;
	if(isPerkExisting("LongRangeGrappling")) {OfficerTypes.(type).perks.LongRangeGrappling = 1};
	if(isPerkExisting("GrapplingProfessional")) {OfficerTypes.(type).perks.GrapplingProfessional = 1};
	if(isPerkExisting("InstantBoarding")) {OfficerTypes.(type).perks.InstantBoarding = 1};
	if(isPerkExisting("HighStakes")) {OfficerTypes.(type).perks.HighStakes = 1};
	if(isPerkExisting("ImproveSmuggling")) {OfficerTypes.(type).perks.ImproveSmuggling = 1};
	if(isPerkExisting("MusketsShoot")) {OfficerTypes.(type).perks.MusketsShoot = 1};
	
	//Cannoneer
	type = OFFIC_TYPE_CANNONEER;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 4;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 2;
	OfficerTypes.(type).skills.Accuracy.importance = 10;
	OfficerTypes.(type).skills.Cannons = 2;
	OfficerTypes.(type).skills.Cannons.importance = 10;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).usableoffictype = true;
	if(isPerkExisting("FastReload")) {OfficerTypes.(type).perks.FastReload = 1};
	if(isPerkExisting("ImmediateReload")) {OfficerTypes.(type).perks.ImmediateReload = 1};
	if(isPerkExisting("HullDamageUp")) {OfficerTypes.(type).perks.HullDamageUp = 1};
	if(isPerkExisting("SailsDamageUp")) {OfficerTypes.(type).perks.SailsDamageUp = 1};
	if(isPerkExisting("CrewDamageUp")) {OfficerTypes.(type).perks.CrewDamageUp = 1};
	if(isPerkExisting("CriticalShoot")) {OfficerTypes.(type).perks.CriticalShoot = 1};
	if(isPerkExisting("LongRangeShoot")) {OfficerTypes.(type).perks.LongRangeShoot = 1};
	if(isPerkExisting("CannonProfessional")) {OfficerTypes.(type).perks.CannonProfessional = 1};
	
	//Quarter Master - Master Purser in fact.
	type = OFFIC_TYPE_QMASTER;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 2;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 1;
	OfficerTypes.(type).skills.Repair.importance = 4;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 2;
	OfficerTypes.(type).skills.Commerce.importance = 10;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).skills.Sneak.importance = 4;
	OfficerTypes.(type).usableoffictype = true;
	OfficerTypes.(type).hpbasebonus = 30;
	if(isPerkExisting("Cooking")) {OfficerTypes.(type).perks.Cooking = 1};
	if(isPerkExisting("BasicCommerce")) {OfficerTypes.(type).perks.BasicCommerce = 1};
	if(isPerkExisting("AdvancedCommerce")) {OfficerTypes.(type).perks.AdvancedCommerce = 1};
	if(isPerkExisting("Trustworthy")) {OfficerTypes.(type).perks.Trustworthy = 1};
	if(isPerkExisting("BasicLandOwner")) {OfficerTypes.(type).perks.BasicLandOwner = 1};
	if(isPerkExisting("ImproveSmuggling")) {OfficerTypes.(type).perks.ImproveSmuggling = 1};
	if(isPerkExisting("AdvanceSmuggling")) {OfficerTypes.(type).perks.AdvanceSmuggling = 1};
	
	
	//Navigator - what is he supposed to do, exactly?...
	type = OFFIC_TYPE_NAVIGATOR;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 3;
	OfficerTypes.(type).skills.Sailing = 2;
	OfficerTypes.(type).skills.Sailing.importance = 10;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;			// set from 0 to 1 by El Rapido Set back to 0 by Levis to balance
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 1;				// set to 1 for compensation of leadership
	OfficerTypes.(type).skills.Sneak.importance = 4;
	OfficerTypes.(type).usableoffictype = true;
	if(isPerkExisting("ShipSpeedUp")) {OfficerTypes.(type).perks.ShipSpeedUp = 1};
	if(isPerkExisting("ShipTurnRateUp")) {OfficerTypes.(type).perks.ShipTurnRateUp = 1};
	if(isPerkExisting("StormProfessional")) {OfficerTypes.(type).perks.StormProfessional = 1};
	if(isPerkExisting("Turn180")) {OfficerTypes.(type).perks.Turn180 = 1};
	if(isPerkExisting("SandbankManeuver")) {OfficerTypes.(type).perks.SandbankManeuver = 1};
	if(isPerkExisting("SailingProfessional")) {OfficerTypes.(type).perks.SailingProfessional = 1};
	
	//First Mate
	type = OFFIC_TYPE_FIRSTMATE;
	OfficerTypes.(type).skills.Leadership = 2;
	OfficerTypes.(type).skills.Leadership.importance = 10;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 3;
	OfficerTypes.(type).skills.Sailing = 1;
	OfficerTypes.(type).skills.Sailing.importance = 5;
	OfficerTypes.(type).skills.Accuracy = 1;			// Set to 1 to balance for few perks
	OfficerTypes.(type).skills.Accuracy.importance = 5;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).usableoffictype = true;
	OfficerTypes.(type).rankbonus = 2;
	OfficerTypes.(type).hpbasebonus = 10;
	OfficerTypes.(type).hplevelbonus = 1;
	if(isPerkExisting("IronWill")) {OfficerTypes.(type).perks.IronWill = 1};
	if(isPerkExisting("SharedExperience")) {OfficerTypes.(type).perks.SharedExperience = 1};
	if(isPerkExisting("Brander")) {OfficerTypes.(type).perks.Brander = 1};
	if(isPerkExisting("FastReload")) {OfficerTypes.(type).perks.FastReload = 1};
	if(isPerkExisting("LongRangeGrappling")) {OfficerTypes.(type).perks.LongRangeGrappling = 1};
	if(isPerkExisting("BasicCommerce")) {OfficerTypes.(type).perks.BasicCommerce = 1};
	
	//Carpenter
	type = OFFIC_TYPE_CARPENTER;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 2;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 2;
	OfficerTypes.(type).skills.Repair.importance = 10;
	OfficerTypes.(type).skills.Defence = 1;
	OfficerTypes.(type).skills.Defence.importance = 5;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).usableoffictype = true;
	if(isPerkExisting("LightRepair")) {OfficerTypes.(type).perks.LightRepair = 1};
	if(isPerkExisting("InstantRepair")) {OfficerTypes.(type).perks.InstantRepair = 1};
	if(isPerkExisting("BasicBattleState")) {OfficerTypes.(type).perks.BasicBattleState = 1};    // added by El Rapido
	if(isPerkExisting("AdvancedBattleState")) {OfficerTypes.(type).perks.AdvancedBattleState = 1};
	if(isPerkExisting("HullDamageUp")) {OfficerTypes.(type).perks.HullDamageUp = 1};
	if(isPerkExisting("ShipSpeedUp")) {OfficerTypes.(type).perks.ShipSpeedUp = 1};
	
	//Doctor
	type = OFFIC_TYPE_DOCTOR;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 2;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 0;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 2;
	OfficerTypes.(type).skills.Defence.importance = 10;
	OfficerTypes.(type).skills.Commerce = 0;		// set to 0 by Levis
	OfficerTypes.(type).skills.Sneak = 2;			// set from 0 to 1 by El Rapido*/ Set to 2 by Levis to compensate for few perks
	OfficerTypes.(type).skills.Sneak.importance = 8;
	OfficerTypes.(type).usableoffictype = true;
	OfficerTypes.(type).CanRand = 1;
	OfficerTypes.(type).hpbasebonus = 30;
	if(isPerkExisting("ImprovePotions")) {OfficerTypes.(type).perks.ImprovePotions = 1};
	if(isPerkExisting("DefendPoison")) {OfficerTypes.(type).perks.DefendPoison = 1};
	if(isPerkExisting("BasicBattleState")) {OfficerTypes.(type).perks.BasicBattleState = 1};
	if(isPerkExisting("AdvancedBattleState")) {OfficerTypes.(type).perks.AdvancedBattleState = 1};
	if(isPerkExisting("ShipDefenceProfessional")) {OfficerTypes.(type).perks.ShipDefenceProfessional = 1};
	if(isPerkExisting("CrewDamageUp")) {OfficerTypes.(type).perks.CrewDamageUp = 1};

	type = OFFIC_TYPE_ABORDAGE;
	OfficerTypes.(type).skills.Leadership = 0;
	OfficerTypes.(type).skills.Fencing = 0;
	OfficerTypes.(type).skills.Fencing.importance = 10;
	OfficerTypes.(type).skills.Sailing = 0;
	OfficerTypes.(type).skills.Accuracy = 0;
	OfficerTypes.(type).skills.Accuracy.importance = 4;
	OfficerTypes.(type).skills.Cannons = 0;
	OfficerTypes.(type).skills.Grappling = 2;		// set to 2 from 1 to balance by Levis
	OfficerTypes.(type).skills.Grappling.importance = 10;
	OfficerTypes.(type).skills.Repair = 0;
	OfficerTypes.(type).skills.Defence = 0;
	OfficerTypes.(type).skills.Defence.importance = 4;
	OfficerTypes.(type).skills.Commerce = 0;
	OfficerTypes.(type).skills.Sneak = 0;
	OfficerTypes.(type).usableoffictype = true;
//	OfficerTypes.(type).CanRand = 1;
	OfficerTypes.(type).EnemyType = 1;
	OfficerTypes.(type).hpbasebonus = 20;
	if(isPerkExisting("LongRangeGrappling")) {OfficerTypes.(type).perks.LongRangeGrappling = 1};
	if(isPerkExisting("GrapplingProfessional")) {OfficerTypes.(type).perks.GrapplingProfessional = 1};
	if(isPerkExisting("InstantBoarding")) {OfficerTypes.(type).perks.InstantBoarding = 1};
	if(isPerkExisting("Troopers")) {OfficerTypes.(type).perks.Troopers = 1};
	if(isPerkExisting("ImproveSmuggling")) {OfficerTypes.(type).perks.ImproveSmuggling = 1};
	
	//Officer which unlocked his mind
	if(isPerkExisting("ImprovePotions")) {OfficerTypes.SuperOfficer.perks.ImprovePotions = 1};
	if(isPerkExisting("DefendPoison")) {OfficerTypes.SuperOfficer.perks.DefendPoison = 1};
	if(isPerkExisting("ShipTurnRateUp")) {OfficerTypes.SuperOfficer.perks.ShipTurnRateUp = 1};
	if(isPerkExisting("ShipSpeedUp")) {OfficerTypes.SuperOfficer.perks.ShipSpeedUp = 1};
	if(isPerkExisting("SandbankManeuver")) {OfficerTypes.SuperOfficer.perks.SandbankManeuver = 1};
	if(isPerkExisting("BasicBattleState")) {OfficerTypes.SuperOfficer.perks.BasicBattleState = 1};
	if(isPerkExisting("AdvancedBattleState")) {OfficerTypes.SuperOfficer.perks.AdvancedBattleState = 1};
	if(isPerkExisting("FastReload")) {OfficerTypes.SuperOfficer.perks.FastReload = 1};
	if(isPerkExisting("HullDamageUp")) {OfficerTypes.SuperOfficer.perks.HullDamageUp = 1};
	if(isPerkExisting("SailsDamageUp")) {OfficerTypes.SuperOfficer.perks.SailsDamageUp = 1};
	if(isPerkExisting("CrewDamageUp")) {OfficerTypes.SuperOfficer.perks.CrewDamageUp = 1};
	if(isPerkExisting("CriticalShoot")) {OfficerTypes.SuperOfficer.perks.CriticalShoot = 1};
	if(isPerkExisting("LongRangeGrappling")) {OfficerTypes.SuperOfficer.perks.LongRangeGrappling = 1};
	if(isPerkExisting("MusketsShoot")) {OfficerTypes.SuperOfficer.perks.MusketsShoot = 1};
	if(isPerkExisting("LightRepair")) {OfficerTypes.SuperOfficer.perks.LightRepair = 1};
	if(isPerkExisting("InstantRepair")) {OfficerTypes.SuperOfficer.perks.InstantRepair = 1};
	if(isPerkExisting("Cooking")) {OfficerTypes.SuperOfficer.perks.Cooking = 1};
	if(isPerkExisting("HighStakes")) {OfficerTypes.SuperOfficer.perks.HighStakes = 1};
	if(isPerkExisting("ImproveSmuggling")) {OfficerTypes.SuperOfficer.perks.ImproveSmuggling = 1};
	if(isPerkExisting("BasicCommerce")) {OfficerTypes.SuperOfficer.perks.BasicCommerce = 1};
	if(isPerkExisting("AdvancedCommerce")) {OfficerTypes.SuperOfficer.perks.AdvancedCommerce = 1};
	if(isPerkExisting("SharedExperience")) {OfficerTypes.SuperOfficer.perks.SharedExperience = 1};
	if(isPerkExisting("IronWill")) {OfficerTypes.SuperOfficer.perks.IronWill = 1};
	if(isPerkExisting("Brander")) {OfficerTypes.SuperOfficer.perks.Brander = 1};
}

string GetBoardingCrewType(ref Captain)
{
	if(!CheckAttribute(Captain, "quest.officertype"))
	{
		trace("ERROR Captain "+Captain.id+" does't have a officertype. This shouldn't happen");
		Captain.quest.officertype = GetCaptainType(Captain);
	}
	if(CheckAttribute(OfficerTypes,Captain.quest.officertype+".crewtype"))
	{
		string officType = Captain.quest.officertype;
		return OfficerTypes.(officType).crewtype;
	}
	return GetRandomEnemyType();
}

int GetHPBaseBonusOT(ref chr)
{
	if(CheckAttribute(chr, "quest.officertype"))
	{
		if(CheckAttribute(OfficerTypes,chr.quest.officertype+".hpbasebonus"))
		{
			string officType = chr.quest.officertype;
			return sti(OfficerTypes.(officType).hpbasebonus);
		}
	}
	return 0;
}

int GetHPLevelBonusOT(ref chr)
{
	if(CheckAttribute(chr, "quest.officertype"))
	{
		if(CheckAttribute(OfficerTypes,chr.quest.officertype+".hplevelbonus"))
		{
			string officType = chr.quest.officertype;
			return sti(OfficerTypes.(officType).hplevelbonus);
		}
	}
	return 0;
}

int GetOfficTypeRankBonus(string officertype)
{
	if(CheckAttribute(OfficerTypes,officertype+".rankbonus"))
	{
		return sti(OfficerTypes.(officertype).rankbonus);
	}
	return 0;
}

int GetCaptainIndexCompanion(ref officer)
{
	if(CheckAttribute(officer,"CompanionOf.idx")) return sti(officer.CompanionOf.idx);
	return -1;
}

void MakeOfficerCaptain(ref officer)
{
	if (CheckAttribute(officer, "quest.officertype")) officer.quest.oldofficertype = officer.quest.officertype; // PB: Just in case
	officer.quest.officertype = GetCaptainType(officer);
}

void RestoreOfficerFromCaptain(ref officer)
{
	if(CheckAttribute(officer,"quest.oldofficertype"))
	{
		officer.quest.officertype = officer.quest.oldofficertype;
	}
	else
	{
		officer.quest.officertype = GetRandomOfficerType();
	}
	DeleteAttribute(officer,"oldofficertype");
}

string GetRandomNPCType()
{
	string retVal = "";
	int numtypes = GetAttributesNum(OfficerTypes);
	int picked;
	int attempts = 0;
	string type;
	Trace("----------------------------------");
	while(retVal == "")
	{
		picked = rand(numtypes-1);
		type = GetAttributeName(GetAttributeN(OfficerTypes,picked));
		if(CheckAttribute(OfficerTypes,type+".CanRand"))
		{
			retVal = type;
		}
		if(attempts>10) retVal = OFFIC_TYPE_CIVILIAN;
		else attempts ++;
	}
	return retVal;
}

string GetRandomEnemyType()
{
	string retVal = "";
	int numtypes = GetAttributesNum(OfficerTypes);
	int picked;
	int attempts = 0;
	string type;
	while(retVal == "")
	{
		picked = rand(numtypes-1);
		type = GetAttributeName(GetAttributeN(OfficerTypes,picked));
		if(CheckAttribute(OfficerTypes,type+".EnemyType"))
		{
			retVal = type;
		}
		if(attempts>10) retVal = OFFIC_TYPE_RANDCHAR;
		else attempts ++;
	}
	return retVal;
}

string GetRandomOfficerType()
{
	string retVal = "";
	int numtypes = GetAttributesNum(OfficerTypes);
	int picked;
	int attempts = 0;
	string type;
	while(retVal == "")
	{
		picked = rand(numtypes-1);
		type = GetAttributeName(GetAttributeN(OfficerTypes,picked));
		if(CheckAttribute(OfficerTypes,type+".usableoffictype"))
		{
			retVal = type;
		}
		if(attempts>10) retVal = OFFIC_TYPE_ABORDAGE;
		else attempts ++;
	}
	return type;
}

bool UsableOfficer(ref _refEnemy)
{
	if(CheckAttribute(_refEnemy,"quest.officertype"))
	{
		if(!CheckAttribute(OfficerTypes,_refEnemy.quest.officertype)) 
		{
			trace("OFFIC TYPE ERROR: Type "+_refEnemy.quest.officertype+" not present");
		}
		else
		{
			if(CheckAttribute(OfficerTypes,_refEnemy.quest.officertype+".usableoffictype"))
			{
				return true;
			}
		}
	}
	return false;
}

int FindFreeRandomOfficer()
{
	// this function rewritten by KAM so new officers don't keep overwriting captains on shore leave [changes made by MAXIMUS 07.10.2007]

	for(int tempnum=0; tempnum<=NUM_RANDOM_OFFICERS; tempnum++) // NK 05-03-30 we now use char not exist to stop loop, so we can have any number of enc_off.
	{
		string tempid = "Enc_Officer_" + tempnum;
		int tempidx = GetCharacterIndex(tempid);
		if(tempidx==-1) break; // NK 05-03-30 ditto
		ref tempChar = GetCharacter(tempidx);

		if(bAllies(tempChar)) { continue; }
		if(tempChar.location == loadedLocation.id) { continue; } // PB: To prevent prospective officers from disappearing when you're talking to them

		ClearCharacter(tempChar); // PB: Completely erase the unused character

		return tempidx;
	}

	return -1;
}

void UseAyahuasca(ref officer)
{
	float a,b,c;
	GetCharacterPos(officer, &a, &b, &c);
	int action = rand(100);
	if(action<=5) //5% chance
	{
		//Kill the officer
		CreateParticleSystem("fire" , a, b+0.0, c, 0.0, 0.0, 0.0, 1);
		CreateParticleSystem("fire" , a, b+0.4, c, 0.0, 0.0, 0.0, 1);
		CreateParticleSystem("fire" , a, b+0.8, c, 0.0, 0.0, 0.0, 1);
		CreateParticleSystem("fire" , a, b+1.2, c, 0.0, 0.0, 0.0, 1);
		CreateParticleSystem("fire" , a, b+1.6, c, 0.0, 0.0, 0.0, 1);
		LAi_KillCharacter(officer);
		Logit(TranslateString("","Officer Got Killed"));
		return;
	}
	if(action<=35)	// 30% chance
	{
		//Poison the officer
		officer.chr_ai.poison = 150;
		Logit(TranslateString("","Officer Got Poisoned"));
		return;
	}
	if(action<=65) //30% chance
	{
		//Add XP
		int exp = (5-GetDifficulty())*pow(sti(officer.rank),0.5)*(rand(7)+3)*1800
		AddCharacterExpNS(officer, exp);
		Logit(TranslateString("","Officer Got Experience"));
		return;
	}
	if(action<=75) //10% Chance
	{
		//Unlock mind
		CreateParticleSystem("stars_short" , a, b+1.0, c, 0.0, 0.0, 0.0, 1);
		MakeSuperOfficer(officer);
		Logit(TranslateString("","Officer Got Unlocked"));
		return;
	}
	//else do nothing
	Logit(TranslateString("","Nothing happened"));
	return;
}

bool MakeSuperOfficer(ref officer)
{
	if(!CheckAttribute(officer,"unlocked_mind"))
	{
		officer.unlocked_mind = true;
		return true;
	}
	return false;
}